#pragma once
#include "messagebasic.h"

/// <summary>
/// ָ·
/// </summary>
struct MESSAGEBASIC_EXPORT NavigateWithRoute : public AbstractMessage {
	QString _route_name;

	NavigateWithRoute();

	// Serializable
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// 
/// </summary>
enum MotionType {
	None,        // û
	StraightLine,// ֱ߻
	StandardArc, // ׼Բ
	ParabolaLine,// 
	Bezier2tArc, // α
	Bezier3tArc, // α
};

/// <summary>
/// Ƕȷ
/// </summary>
enum class MotionRotate {
	Horizontal, Vertical
};

/// <summary>
/// ӿ
/// </summary>
struct OrthogonalMotionCommand : public Serializable {
	/// <summary>
	/// ƽ淽
	/// </summary>
	/// <returns></returns>
	virtual MotionRotate rotateType() const = 0;
	/// <summary>
	/// 
	/// </summary>
	/// <returns></returns>
	virtual MotionType motionType() const = 0;
	/// <summary>
	/// ָٷֱλ
	/// </summary>
	/// <param name="percent"></param>
	/// <returns></returns>
	virtual LonLatAltPos posAtPercent(double percent) = 0;
	/// <summary>
	/// ָٷֱλõٶ
	/// </summary>
	/// <param name="percent"></param>
	/// <returns></returns>
	virtual double speedAtPercent(double percent) = 0;
	/// <summary>
	/// ָٷֱλٶȷ
	/// </summary>
	/// <param name="percent"></param>
	/// <returns></returns>
	virtual QVector2D speedVectorAtPercent(double percent) = 0;
};

/// <summary>
/// ƽ̨
/// </summary>
struct PlatformMotionCommand : public AbstractMessage {
	QHash<MotionRotate, std::shared_ptr<OrthogonalMotionCommand>> _motion_set; //ϳɻ
	double _arrived_time = 0; // ִյʱ
	double _start_time = 0;

	PlatformMotionCommand();

	// Serializable
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// 鿴ָĿʵĻָ
/// </summary>
struct MESSAGEBASIC_EXPORT MotionSequencePreviewGet : public AbstractMessage {
	MotionSequencePreviewGet();
};

/// <summary>
/// ƽ̨
/// </summary>
struct MESSAGEBASIC_EXPORT PlatformMotionSequence : public AbstractMessage {
	QList<std::shared_ptr<PlatformMotionCommand>> _cmd_sequence;

	PlatformMotionSequence();

	// Serializable
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};


// ʵ =======================================================

/// <summary>
/// ˮƽֱ߻
/// </summary>
struct MESSAGEBASIC_EXPORT HorizontalLineMotionCmd : public OrthogonalMotionCommand {
	LonLatPos _lonlat_anchor;// ʼ
	double _azimuth_deg = 0; // ʼλ
	double _speed_value = 0;// ʼٶ
	double _accerlate_rate = 0;// ٶ

	HorizontalLineMotionCmd();

	// Serializable
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;

	MotionRotate rotateType() const override;
	MotionType motionType() const override;
	LonLatAltPos posAtPercent(double percent) override;

};

struct MESSAGEBASIC_EXPORT VerticalLineMotionCmd : public OrthogonalMotionCommand {

};